package com.njcn.device.pms.utils;

import cn.hutool.core.util.StrUtil;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.EnumUtils;
import com.njcn.device.pms.enums.PmsDeviceResponseEnum;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * @author hongawen
 * @version 1.0.0
 * @date 2021年12月20日 10:03
 */
public class PmsDeviceEnumUtil {


    /**
     * 获取PmsDeviceResponseEnum实例
     */
    public static PmsDeviceResponseEnum getDeviceEnumResponseEnumByMessage(@NotNull Object value) {
        PmsDeviceResponseEnum deviceResponseEnum;
        try {
            String message = value.toString();
            if(message.indexOf(StrUtil.C_COMMA)>0){
                value = message.substring(message.indexOf(StrUtil.C_COMMA)+1);
            }
            deviceResponseEnum = EnumUtils.valueOf(PmsDeviceResponseEnum.class, value, PmsDeviceResponseEnum.class.getMethod(BusinessException.GET_MESSAGE_METHOD));
            return Objects.isNull(deviceResponseEnum) ? PmsDeviceResponseEnum.DEVICE_COMMON_ERROR : deviceResponseEnum;
        } catch (NoSuchMethodException e) {
            throw new BusinessException(CommonResponseEnum.INTERNAL_ERROR);
        }
    }

    public static Enum<?> getExceptionEnum(HttpResult<Object> result){
        //如果返回错误，且为内部错误，则直接抛出异常
        CommonResponseEnum commonResponseEnum = EnumUtils.getCommonResponseEnumByCode(result.getCode());
        if (commonResponseEnum == CommonResponseEnum.DEVICE_RESPONSE_ENUM) {
            return getDeviceEnumResponseEnumByMessage(result.getMessage());
        }
        return commonResponseEnum;
    }




}
